//subtitle and lables + controlP5
int textFieldX = 900 - 230;


void gui(){
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  if(title) drawtitle();
  
  cp5.draw();
  
  //draw book descriptions
  if(bookDescription != null){
      textFont(font);
      fill(255, 255, 255, 50);
      noStroke();
      rect(textFieldX - 10, 58, 220, 100, 10);
      
      fill(50, 50, 120);
      textSize(14);
      text(bookDescription, textFieldX , 77);
     
  }
  
  textFont(font);
  fill(255, 255, 255, 200);
  textSize(14);
  text("Length of white lines:   loan days", 420, 30);
  text("Upper layer:     new fiction books", 420, 45);
  text("Lower layer:     non-fiction books", 420, 60);
  
  
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
  
  //drawlables();
}


void drawtitle(){
  textSize(32);
  fill(80, 80, 140, 100);
  text("How Do New Books Behave", 45, height/2 + 110);
  fill(80, 80, 140);
  text("How Do New Books Behave", 40, height/2 + 105);
  fill(50, 50, 120);
  textSize(16);
  text("Seattle Public Library Data Visualization", 43, height/2 + 130);
  text("Hilda Chang HE", 43, height/2 + 150);
  text("winter", 80, height/2 + 170);  
  //textSize(12);
  text("2016", 43, height/2 + 170);
  
}

//TODO***************************
void drawlablesF(){
  //Time lable on fiction
  stroke(0,0,0,200);
  noFill();
  strokeWeight(1);
  pushMatrix();
  rotateY(PI/2);
  translate(300, 0, 0);
  ellipse(0, 0, 650, 50);
    pushMatrix();
    translate(0,0,xrange);
    ellipse(0, 0, 650, 50);
    popMatrix();
    
    pushMatrix();
    translate(0,0,-xrange);
    ellipse(0, 0, 650, 50);
    popMatrix();
  popMatrix();
  
  textSize(20);
  fill(0);
  pushMatrix();
  translate(10,0,-500);
    pushMatrix();
    rotateX(PI/4);
    text("2015", 0, 0);
    text("2014", -65, 0);
    popMatrix();
  popMatrix();
  
  pushMatrix();
  translate(810,0,-500);
    pushMatrix();
    rotateX(PI/4);
    text("2016", 0, 0);
    text("2015", -65, 0);
    popMatrix();
  popMatrix();
 
   pushMatrix();
  translate(-790,0,-500);
    pushMatrix();
    rotateX(PI/4);
    text("2014", 0, 0);
    text("2013", -65, 0);
    popMatrix();
  popMatrix();
  
  
}

void controlPanel(){
    font = createFont("Calibri", 70);
    textFont(font);
    
    //get input from user for book title
    cp5.addTextfield("bookTitle")
     .setPosition(textFieldX,20)
     .setSize(150,20)
     .setFont(createFont("arial",14))
     .setAutoClear(false)
     ;
     
    //clear bang
    cp5.addBang("clear")
     .setPosition(textFieldX + 170,20)
     .setSize(30,20)
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ; 
     
    // make check box to let user select years
    yearCheckbox = cp5.addCheckBox("yearCheckbox")
                .setPosition(20, 20)
                .setSize(20, 20)
                .setItemsPerRow(3)
                .setSpacingColumn(35)
                .setSpacingRow(20)
                .addItem("2013", 2013)
                .addItem("2014", 2014)
                .addItem("2015", 2015)
                ;
     cp5.addButton("Titles")
        //.setValue()
        .setPosition(300, 20)
        .setSize(50, 20)
        ;
     //make control panel stay
     cp5.setAutoDraw(false);
}

public void bookTitle(String theText) {
    // automatically receives results from controller input
    println("a textfield event for controller 'bookTitle' : "+theText);
  
    name = cp5.get(Textfield.class,"bookTitle").getText();
    println("get input from bookTitle as: " + name);
    if(name != null && !name.equals("")){
      if(switch2015 == true){
        points = fiction2015.findBooksByName(name);
        yearIndicator = 2015;
      }
      if(switch2014 == true && points == null){
        points = fiction2014.findBooksByName(name);
        yearIndicator = 2014;
      }
      if(switch2013 == true && points == null){
        points = fiction2013.findBooksByName(name);
        yearIndicator = 2013;
      }
      if(points == null) println("nothing found");
    }
}

public void clear() {
   //println(cp5.get(Textfield.class,"textValue"));
   cp5.get(Textfield.class,"bookTitle").clear();
   name = "";
   points = null;
   bookDescription = "";
}

void yearCheckbox(float[] a) {
    //println("got an event from "+yearCheckbox.getName());
    //println(yearCheckbox.getArrayValue());
    //2013 selected
    if(a[0] == 1){
      switch2013 = true;
    }else{
      switch2013 = false;
    }
    
    if(a[1] == 1){
      switch2014 = true;
    }else{
      switch2014 = false;
    }
    
    if(a[2] == 1){
      switch2015 = true;
    }else{
     switch2015 = false; 
    }
    
}

void Titles(){
  if(title){
    title = false;
  }else{
    title = true;
  }
}

//void controlEvent(ControlEvent theEvent) {
//    if(theEvent.isAssignableFrom(Textfield.class)) {
//      println("controlEvent: accessing a string from controller '"
//              +theEvent.getName()+"': "
//              +theEvent.getStringValue()
//              );  
//    }
//}